(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['module'], factory);
  } else if (typeof exports !== "undefined") {
    factory(module);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod);
    global.darkness = mod.exports;
  }
})(this, function (module) {
  'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var Darkness = function () {
    function Darkness() {
      _classCallCheck(this, Darkness);

      this.bodyElem = document.querySelector('body');
      this._isToggling = false;
      this._isOpened = false;
      this.createElement();
    }

    _createClass(Darkness, [{
      key: 'createElement',
      value: function createElement() {
        var el = document.createElement('div');
        el.classList.add('c-darkness');
        var innerEl = document.createElement('div');
        innerEl.classList.add('c-darkness__inner');

        el.appendChild(innerEl);
        this.bodyElem.appendChild(el);
      }
    }, {
      key: 'summon',
      value: function summon(shouldAnimate, time) {
        if (!this._isOpened) {
          if (!shouldAnimate) {
            this._open();
          } else if (shouldAnimate && time) {
            this._animateOpen(time);
          }
        }
      }
    }, {
      key: 'dismiss',
      value: function dismiss(shouldAnimate, time) {
        if (this._isOpened) {
          if (!shouldAnimate) {
            this._close();
          } else if (shouldAnimate && time) {
            this._animateClose(time);
          }
        }
      }
    }, {
      key: '_open',
      value: function _open() {
        this.bodyElem.classList.add('darkness-has-come');
        this._isOpened = true;
      }
    }, {
      key: '_animateOpen',
      value: function _animateOpen(time) {
        var _this = this;

        this.bodyElem.classList.add('darkness-is-comming');

        setTimeout(function () {
          _this.bodyElem.classList.remove('darkness-is-comming');
          _this._open();
          _this._isOpened = true;
        }, time);
      }
    }, {
      key: '_close',
      value: function _close() {
        this.bodyElem.classList.remove('darkness-has-come');
        this._isOpened = false;
      }
    }, {
      key: '_animateClose',
      value: function _animateClose(time) {
        var _this2 = this;

        this._close();
        this.bodyElem.classList.add('darkness-is-leaving');

        setTimeout(function () {
          _this2.bodyElem.classList.remove('darkness-is-leaving');
          _this2._isOpened = false;
        }, time);
      }
    }, {
      key: '_isOpened',
      value: function _isOpened() {
        return this.isOpened;
      }
    }, {
      key: '_setToggler',
      value: function _setToggler(state) {
        if (state) {
          this.isToggling = state;
        } else {
          this.isToggling = !this.isToggling;
        }
      }
    }]);

    return Darkness;
  }();

  module.exports = new Darkness();
});
